/* ǡ null ǡɲ
 * 12/30 2003
 * shige
 * sndnull.c
 *
 * $Id: sndnull.c,v 1.4 2004-01-13 15:39:08+09 shige Exp $
 */
/* sndnull [n] [m] ([infile])
 *   -s (m û), -o (ϥե)  support 뤫
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

int main(int argc,char *argv[]);
void putdatavol(FILE *outfile,FILE *infile,double vol[],SNDheader *snd,
                int format);
int getarg(int argc,char **argv,long int *n,long int *m,FILE **infile,
	   FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    SNDheader snd;
    FILE *infile,*outfile;
    int format,ret,bs,ch;
    long int n,m,blocks,j,dlen;
    
    if((ret=getarg(argc,argv,&n,&m,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
#if 0
    fprintf(stderr,"(n,m)=(%ld,%ld)\n",n,m);
#endif
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
	fprintf(stderr,"Error: In getSNDheader(). (%d)\n",format);
	return 1;
    }
    blocks=SNDblocks(&snd,format);
    bs=SNDblocksize(&snd,format);
    ch=SNDchannels(&snd,format);
    dlen=SNDdatalen(&snd,format);
    putSNDheaderBlocks(outfile,&snd,blocks+n+m,format);
    for(j=1;j<=n*ch;j++) SNDputnull1ch(outfile,&snd,format);
    for(j=1;j<=dlen;j++) fputc(fgetc(infile),outfile);
    for(j=1;j<=m*ch;j++) SNDputnull1ch(outfile,&snd,format);
    if(format!=E_AU && bs%2 && (blocks+n+m)%2) fputc(0,outfile);
    return 0;
}

int getarg(int argc,char **argv,long int *n,long int *m,FILE **infile,
	   FILE **outfile)
{
    *infile=stdin; *outfile=stdout;

    if(argc<3) return -1;
    if((*n=atol(argv[1]))<0 || (*m=atol(argv[2]))<0) return -2;
    if(argc>=4 && strcmp(argv[3],"-") && (*infile=fopen(argv[3],"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",argv[3]);
	return -3;
    }
    if(argc>=5 && strcmp(argv[4],"-") && (*outfile=fopen(argv[4],"w"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",argv[4]);
	return -4;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndnull [n] [m] ([infile] ([outfile]))",
	"   [n]      : ƬˤĤǡΥ֥å",
	"   [m]      : ǸˤĤǡΥ֥å",
	"   [infile] : ϥե (ά: ɸ)",
	"   [outfile]: ϥե (ά: ɸ)",
	" ",
	" [1] /ϥե '-' ꤷɸ/Ϥˤʤ롣",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
