/* ƬФ tool ѥإåե
 * funa@nolm01.iee.niit.ac.jp, shige
 * 02/24 2001
 * auslcut.h
 *
 * $Id: auslcut.h,v 1.1 2001-03-03 18:27:17+09 shige Exp $
 */
#ifndef __AUSLCUT_H__
#define __AUSLCUT_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef __AUSLCUT_C__
# define EXTERN_AUSLCUT 
#else
# define EXTERN_AUSLCUT extern 
#endif

/* ########## macros ########## */
enum Sndformats { E_AU=0, E_WAV, E_AIFF, E_UNKNOWN };
enum Options { E_SH=1, E_SN, E_SP, E_TMP };

#define MaxBuff 800
#define MaxLevel 20
#define MaxDivide 9

/* ##### Default values ##### */
/* ʲɬפʤĶ˹碌ƽΤȡ*/
/*  */
#define DIVIDE 3
#define MINLEN 1.0
#define SNDLEN 500
#define MINSIZE 5
#define SNDBLOCK 4000
#define int45(x) ((int)((x)+0.5))
#define ms2blck(x) ((double)(x)*SamplingRate/1000.0)
#define blck2ms(n) ((double)(n)*1000.0/SamplingRate)
#define VERBOSE 0
#define PUTKEY 0
#define TMPDIR "/tmp"
#define HEADSND "poo"
#define NULLSND "empty"
#define BACKWARD 1
#define USEMILLISEC 1
#define OUTFNAME "-"

#ifndef SNDFORMAT
# define SNDFORMAT E_AU
#endif

#ifdef USEPLOTSOUND
# ifndef PLOTSOUND
#  define PLOTSOUND 0
# endif
# ifndef SOX
#  define SOX "sox"
# endif
# ifndef GNUPLOT
#  define GNUPLOT "gnuplot"
# endif
# define TMPDATFILE "/tmp/tmp.dat"
#endif

#ifndef AUSUBSTR
# define AUSUBSTR "ausubstr"
#endif
#ifndef WAVSUBSTR
# define WAVSUBSTR "wavsubstr"
#endif
#ifndef AIFFSUBSTR
# define AIFFSUBSTR "aiffsubstr"
#endif
#ifndef AUCONN
# define AUCONN "auconn"
#endif
#ifndef WAVCONN
# define WAVCONN "wavconn"
#endif
#ifndef AIFFCONN
# define AIFFCONN "aiffconn"
#endif
#ifndef AUPLAY
# define AUPLAY "| auplay"
/* On Solaris */
/* #define AUPLAY "| cat | /bin/audioplay -" */
#endif
#ifndef WAVPLAY
# define WAVPLAY "| wavplay"
#endif
#ifndef AIFFPLAY
# define AIFFPLAY "| aiffplay"
#endif

#ifndef AUFINFO
# define AUFINFO "aufinfo"
#endif

#ifdef __AUSLCUT_C__
char *ausubstr[]={ AUSUBSTR, WAVSUBSTR, AIFFSUBSTR };
char *auconn[]={ AUCONN, WAVCONN, AIFFCONN };
char *auext[]={ "au", "wav", "aiff" };
char *auplay[]={ AUPLAY, WAVPLAY, AIFFPLAY };
char *CommandNames[]={"auslcut","wavslcut","aiffslcut"};
#endif
/* ޤ */

/* ##### extern valiables ##### */
/* ǽ˽ѲʤΤʤ */
EXTERN_AUSLCUT int SoundFormat;
EXTERN_AUSLCUT double MinimumSize;
EXTERN_AUSLCUT double SamplingRate;
EXTERN_AUSLCUT char *TempDir;
EXTERN_AUSLCUT char *TempFnameHead="auslcut-";
EXTERN_AUSLCUT char *PlayComm;
EXTERN_AUSLCUT char *HeadSound, *NullSound;
EXTERN_AUSLCUT int BackwardPlay;

/* ########## prototype declaration ########## */
EXTERN_AUSLCUT int main(int argc,char *argv[]);
EXTERN_AUSLCUT int setinit(int mode,int divide,char tmpfnames[][MaxBuff],
			   char *fname,char **Outf,int *size,int *sndblock,
			   double minvalue,int sndvalue,
#ifdef USEPLOTSOUND
			  int plotsnd,
#endif
			  int verbose);
EXTERN_AUSLCUT void mktmpfnames(int divide,char tmpfnames[][MaxBuff]);
EXTERN_AUSLCUT void putsound(int skip,char *fname,int N,int pos[],int size,
			     int sndblock,char tmpfnames[][MaxBuff]);
EXTERN_AUSLCUT int setpos(int pos[],int divide,int ctop,int clast);
EXTERN_AUSLCUT void atlast(char *outf,char *fname,int mode,int level,
			   int divide,int verbose,int pos,int ctop[],
			   int clast[],int cpos[],char tmpfnames[][MaxBuff]);
EXTERN_AUSLCUT void puthistory(int mode,int divide,int level,int pos,
			       int ctop[],int clast[],int cpos[]);
EXTERN_AUSLCUT void outputresult(char *outfname,char *fname,int pos);
EXTERN_AUSLCUT int getkey(int putkey,int divide);
EXTERN_AUSLCUT int arganal(int argc,char *argv[],int *Divide,
			   double *MinValue,int *SndValue,
			  int *Verbose,int *Putkey,int *UseMilliSec,
#ifdef USEPLOTSOUND
			  int *PlotSnd,
#endif
			  char **TmpDir,char **HeadSnd,char **NullSnd,
			  char **SndCmd,int *Backward,int *SndForm,
			  char **Fname,char **OutFile);
EXTERN_AUSLCUT int setdefaultSndForm(char *commname);
#ifdef USEPLOTSOUND
EXTERN_AUSLCUT int plotcontrol(int mode,int mode2,char *fname,int N,
			      int pos[],int size);
#endif
EXTERN_AUSLCUT int getdatasize(char *fname);
EXTERN_AUSLCUT int getsamplingrate(char *fname);
EXTERN_AUSLCUT double getsoundlen(char *fname);
EXTERN_AUSLCUT int getsoundblocks(char *fname);
EXTERN_AUSLCUT void usage(char *name);

#endif /* __AUSLCUT_H__ */
