/* 
 * blitspin 롣
 * shige
 * 01/12 2004
 * 
 * $Id: snddvrev.c,v 1.3 2005-01-05 19:51:37+09 shige Exp $
 *
 * tmpfile Ȥ
 */
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

int main(int argc,char *argv[]);
int getarg(int argc,char **argv,int *N,FILE **infile,FILE **outfile);
void usage(int ret);

/* 椬ʬΤȤɤ뤫ä꤫⡣*/

int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    SNDheader snd;
    int format,ch,bs;
    long int dlen,blocks,start,last,nums;
    FILE *tmp;
    int j,k,ret,n,N;
    double x;
#ifdef DEBUG1
    long int hlen;
#endif

    if((ret=getarg(argc,argv,&N,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
        fprintf(stderr,"get header error.\n");
        return 3;
    }
    put1SNDheader(outfile,&snd,format);
    dlen=SNDdatalen(&snd,format);
#ifdef DEBUG1
    hlen=SNDhlen(&snd,format);
#endif
    if(infile==stdin){
	if((tmp=tmpfile())==NULL) return 1;
	for(j=1;j<=dlen;j++) fputc(fgetc(infile),tmp);
	fclose(infile);
	if(fseek(tmp,0L,SEEK_SET)<0) return 1;
	infile=tmp;
#ifdef DEBUG1
	hlen=0L;
#endif
    }
    ch=SNDchannels(&snd,format);
    blocks=SNDblocks(&snd,format);
    bs=SNDblocksize(&snd,format);
    x=(double)blocks/N;
    for(n=1;n<=N;n++){
	start=(n-1)*x+1;
	last=(n==N)?blocks:n*x;
	nums=last-start+1;
	fseek(infile,nums*ch,SEEK_CUR);
#ifdef DEBUG1
	fprintf(stderr,"[%d] ftell() = %ld, nums=%ld\n",
		n,ftell(infile)-hlen,nums);
#endif
	for(j=1;j<=nums;j++) {
	    for(k=1;k<=ch;k++) SNDreadput1chdata(infile,outfile,&snd,format);
	    fseek(infile,-bs,SEEK_CUR);
	    fseek(infile,-bs,SEEK_CUR);
	}
	fseek(infile,nums*ch,SEEK_CUR);
    }
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}

int getarg(int argc,char **argv,int *N,FILE **infile,FILE **outfile)
{
    *outfile=stdout;
    *infile=stdin;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc<1 || argc>2){
#ifdef DEBUG1
	fprintf(stderr,"DEBUG1: %d\n",argc);
#endif
	return -7;
    }
    if((*N=atoi(*argv))<=0) return -8;
    if(--argc<1 || !strcmp(*(++argv),"-") ||(*infile=fopen(*argv,"r"))!=NULL)
      return 1;
    else{
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -9;
    }
}

void usage(int ret)
{
    char *mess[]={
	"Usage: snddvrev (-o [outfile]) [n] ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [infile]: ϥե (ά: ɸ)",
	"   [n] : ʬ ([n]  1 ʾ",
	" ",
	" [1] ϥեϡ̵ꡢ뤤 '-' ꤷɸ",
	"     Ϥˤʤ롣",
	" [2] [n] ʬ䤷줾ʬղ󤷤롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
